;==================================================================
;Titel des Projektes:	AutoIt fr BB (AI-BB)
;
;Autor:					Badudel (Yaron Strauch)
;
;Email:					badudel@web.de
;
;Version:				0.8 (Pre-Alpha)
;
;Datum:					23.10.2009
;
;Kurzes Howto:			1. Dies hier Includieren
;						2. Die AI.exe dem Projekt hinzufgen (Ordner wie BB-Datei, ansonsten den Pfad unten ndern (erste Zeile unter
;																												dieser Kommentarbox)
;						3. Um die Engine zu starten benutze AI_Start
;						4. Benutze die Funktionen unten. Syntax steht dahinter.
;						Parameter sind fast immer gleich denen von AutoIt. Returns erfolgen wie gewohnt.
;						5. BEENDE DIE ENGINE IMMER MIT 	AI_End, SONST BLEIBT SIE AM LAUFEN!!!
;
;Anmerkungen:			- Ich erstelle vielleicht demnchst noch eine Hilfeseite, wo man alle Befehle samt Syntax und
;						nderungen nachschlagen kann. Guck einfach mal dort rein, wo du das hier herbekommen hast.
;						- Wegen Speicherverbrauch: Bei der BB-Datei hoffe ich, du komprimierst die fertige Exe sowieso,
;						bei der AI.exe kann man noch die nicht gebrauchten Funktionen einsparen, ich kann auf Anfrage den
;						AI-Quelltext senden, sodass Du Dir einfach die nicht gebrauchten Funktionen rausentfernen kannst.
;						- Dir fehlt ein wichtiger Befehl aus AutoIt? Mail mich an!
;
;Disclaimer				Benutzung auf eigene Gefahr. Reicht das? Wenn nicht:
;						Keine Garantie, kein Anspruch auf Support, keine Haftung bei Schden an Hard- oder Software.
;
;Anmerkung Pre-Alpha :	Dies ist die allererste Version. Es kommen hchstwahrscheinlich noch Fehler bei den Returnwerten und der
;						Fehlerberprfung vor, auch sonstige... Bugreports sind willkommen an meine Mail, es sei denn, diese
;						Version ist lter als ein viertel Jahr.
;
;Lizenz:				Lizenzteilnehmer sind: Yaron Strauch und AutoIt.
;						Meine Bedingungen: Fr Benutzung im Nicht-Kommerziellen Bereich: Erwhnung in den Credits,
;						und bei greren Projekten freue ich mich ber eine Nachricht darber.
;						AutoIt: Die Lizenz liegt bei. Du musst ihr entsprechen und bei allen Projekten sie beilegen
;						und beachten, sie gelten bei allen Projekten, die Du damit erstellst (!).
;            
;====================================================================


Const AI_Pfad$="";Lasse man leer, wenn die AI.exe im Hauptordner ist.
;Ansonsten den Pfad vom Hauptordner aus beschreiben und mit / abschlieen (!!!)
;Beispiel: "AI-Engine/" oder "Misc/AI/"

AI_Uebergabe$=CurrentDir$()+AI_Pfad


Global letzter$=""
Global AI_Timer=CreateTimer(30)

Function AI_Start()
AI_out=WriteFile (AI_Pfad$+"AI_out.ai")
AI_in=WriteFile (AI_Pfad$+"AI_in.ai")
DeleteFile(AI_Pfad$+"AI_error.ai")
If FileType(AI_Pfad$+"AI.exe")=0 Then RuntimeError("AI-Engine nicht gefunden.")
ExecFile(AI_Pfad$+"AI.exe "+Chr(132)+AI_Uebergabe+Chr(132))
letzter$="Start"
CloseFile AI_out
CloseFile AI_in
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_End()
AI_Intern_Write("End")
letzter$="End"
ret=AI_Intern_waitReturn()

DeleteFile AI_Pfad$+"AI_out.ai"
DeleteFile AI_Pfad$+"AI_in.ai"
DeleteFile AI_Pfad$+"AI_HotKeyPressed.ai"
DeleteFile AI_Pfad$+"AI_error.ai"
Return ret
End Function

Function AI_GetError()
exist=FileType(AI_Pfad$+"AI_error.ai")
If exist=0 Then Return 0
AI_error=ReadFile(AI_Pfad$+"AI_error.ai")
error=ReadLine(AI_error)
CloseFile AI_error
DeleteFile "AI_Error.ai"
Return error
End Function




Function AI_HotKeySet(key$)
AI_Intern_Write("HotKeySet("+key$+")")
letzter$="HotKeySet"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_HotKeyPressed(key$)
While file=0
	file=ReadFile(AI_Pfad$+"AI_HotKeyPressed.ai")
	WaitTimer AI_Timer
Wend

While Not Eof(file)
	txt$=ReadLine(file)
	If txt$=key$
		CloseFile file
		Return 1
	EndIf
	WaitTimer AI_Timer
Wend

CloseFile file
Return 0
End Function


Function AI_HotKeyUnSet(key$=-1)
AI_Intern_Write("HotKeyUnSet("+key$+")")
letzter$="HotKeyUnSet"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ToolTip(txt$,x=-1,y=-1,titel$=-1,icon=-1,timeout=-1)
AI_Intern_Write("ToolTip("+txt$+Chr$(1)+x+Chr$(1)+y+Chr$(1)+titel$+Chr$(1)+icon+Chr$(1)+timeout+")")
letzter$="ToolTip"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_Send(key$,flag=-1)
AI_Intern_Write("Send("+key$+Chr$(1)+flag+")")
letzter$="Send"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_MouseMove(x,y,speed=-1)
AI_Intern_Write("MouseMove("+x+Chr$(1)+y+Chr$(1)+speed+")")
letzter$="MouseMove"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_MouseClick(taste,x=-1,y=-1,clicks=-1,speed=-1)
AI_Intern_Write("MouseClick("+taste+Chr$(1)+x+Chr$(1)+y+Chr$(1)+clicks+Chr$(1)+speed+")")
letzter$="MouseClick"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_MouseClickDrag(taste,x1,y1,x2,y2,speed=-1)
AI_Intern_Write("MouseClickDrag("+taste+Chr$(1)+x1+Chr$(1)+y1+Chr$(1)+x2+Chr$(1)+y2+Chr$(1)+speed+")")
letzter$="MouseClickDrag"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_MouseDown(taste=-1)
AI_Intern_Write("MouseDown("+taste+")")
letzter$="MouseDown"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_MouseUp(taste)
AI_Intern_Write("MouseUp("+taste+")")
letzter$="MouseUp"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_MouseGetPos(posachse)
AI_Intern_Write("MouseGetPos("+posachse+")")
letzter$="MouseGetPos"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_MouseWheel(richtung,mal=-1)
AI_Intern_Write("MouseWheel("+richtung+Chr$(1)+mal+")")
letzter$="MouseWheel"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_MsgBox(flag,titel$,Text$,timeout=-1)
AI_Intern_Write("MsgBox("+flag+Chr$(1)+titel$+Chr$(1)+Text$+Chr$(1)+timeout+")")
letzter$="MsgBox"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ShutDown(art)
AI_Intern_Write("ShutDown("+art+")")
letzter$="ShutDown"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_Beep(freq=-1,dauer=-1)
AI_Intern_Write("Beep("+freq+Chr$(1)+dauer+")")
letzter$="Beep"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_CDTray(laufwerk,zustand)
AI_Intern_Write("CDTray("+laufwerk+Chr$(1)+zustand+")")
letzter$="CDTray"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ClipGet$()
AI_Intern_Write("ClipGet()")
letzter$="ClipGet"
ret$=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ClipPut(txt$)
AI_Intern_Write("ClipPut("+txt$+")")
letzter$="ClipPut"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_FileGetSize(file$)
AI_Intern_Write("FileGetSize("+file$+")")
letzter$="FileGetSize"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_FileGetTime(name$,option)
AI_Intern_Write("FileGetTime("+name$+Chr$(1)+option+")")
letzter$="FileGetTime"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_FileSetTime(file$,zeit,typ=-1,recurse=-1)
AI_Intern_Write("FileSetTime("+file$+Chr$(1)+zeit+Chr$(1)+typ+Chr$(1)+recurse+")")
letzter$="FileSetTime"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_FileSaveDialog$(titel$,anfangsverz$,filter$,optionen=-1,standardname$=-1)
AI_Intern_Write("FileSaveDialog("+titel$+Chr$(1)+anfangsverz$+Chr$(1)+filter$+Chr$(1)+optionen+Chr$(1)+standardname$+")")
letzter$="FileSaveDialog"
ret$=AI_Intern_waitReturn()
Return ret
End Function

Function AI_FileOpenDialog$(titel$,anfangsverz$,filter$,optionen=-1,standardname$=-1)
AI_Intern_Write("FileOpenDialog("+titel$+Chr$(1)+anfangsverz$+Chr$(1)+filter$+Chr$(1)+optionen+Chr$(1)+standardname$+")")
letzter$="FileOpenDialog"
ret$=AI_Intern_waitReturn()
Return ret
End Function

Function AI_FileSelectFolder$(txt$,ursprung$,flag=-1,standardverz$=-1)
AI_Intern_Write("FileSelectFolder("+txt$+Chr$(1)+ursprung$+Chr$(1)+flag+Chr$(1)+standardverz$+")")
letzter$="FileSelectFolder"
ret$=AI_Intern_waitReturn()
Return ret
End Function

Function AI_InputBox$(titel$,prompt$,def$=-1,pwdchar$=-1,breite=-1,hoehe=-1,links=-1,oben=-1,timeout=-1)
AI_Intern_Write("InputBox("+titel$+Chr$(1)+prompt$+Chr$(1)+def$+Chr$(1)+pwdchar$+Chr$(1)+breite+Chr$(1)+hoehe+Chr$(1)+links+Chr$(1)+oben+Chr$(1)+timeout+")")
letzter$="InputBox"
ret$=AI_Intern_waitReturn()
Return ret
End Function

Function AI_IsAdmin()
AI_Intern_Write("IsAdmin()")
letzter$="IsAdmin"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_Ping(adresse,timeout=-1)
AI_Intern_Write("Ping("+adresse+Chr$(1)+timeout+")")
letzter$="Ping"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ProcessClose(process$)
AI_Intern_Write("ProcessClose("+process$+")")
letzter$="ProcessClose"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ProcessExists(process$)
AI_Intern_Write("ProcessExists("+process$+")")
letzter$="ProcessExists"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ProcessSetPriority(process$,prioritaet)
AI_Intern_Write("ProcessSetPriority("+process$+Chr$(1)+prioritaet+")")
letzter$="ProcessSetPriority"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ProcessWait(process$,timeout=-1)
AI_Intern_Write("ProcessWait("+process$+Chr$(1)+timeout+")")
letzter$="ProcessWait"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ProcessWaitClose(process$,timeout=-1)
AI_Intern_Write("ProcessWaitClose("+process$+Chr$(1)+timeout+")")
letzter$="ProcessWaitClose"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ProgressOn(titel$,maintext$,subtext$=-1,x=-1,y=-1,opt=-1)
AI_Intern_Write("ProgressOn("+titel$+Chr$(1)+maintext$+Chr$(1)+subtext$+Chr$(1)+x+Chr$(1)+y+Chr$(1)+opt+")")
letzter$="ProgressOn"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ProgressSet(prozent,subtext$=-1,maintext$=-1)
AI_Intern_Write("ProgressSet("+prozent+Chr$(1)+subtext$+Chr$(1)+maintext$+")")
letzter$="ProgressSet"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_ProgressOff()
AI_Intern_Write("ProgressOff()")
letzter$="ProgressOff"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_RegRead$(key$,wert)
AI_Intern_Write("RegRead("+key$+Chr$(1)+wert+")")
letzter$="RegRead"
ret$=AI_Intern_waitReturn()
Return ret
End Function

Function AI_RegDelete(key$,wert)
AI_Intern_Write("RegDelete("+key$+Chr$(1)+wert+")")
letzter$="RegDelete"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_RegWrite(key$,wertname$,typ$,wert)
AI_Intern_Write("RegWrite("+key$+Chr$(1)+wertname$+Chr$(1)+typ$+Chr$(1)+wert+")")
letzter$="RegWrite"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_SendKeepActive(windowtitel$,windowtextinhalt$=-1)
AI_Intern_Write("SendKeepActive("+windowtitel$+Chr$(1)+windowtextinhalt$+")")
letzter$="SendKeepActive"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_WinActivate(wintitel$,wintextinhalt$=-1)
AI_Intern_Write("WinActivate("+wintitel$+Chr$(1)+wintextinhalt$+")")
letzter$="WinActivate"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_WinActive(wintitel$,wininhalt$=-1)
AI_Intern_Write("WinActive("+wintitel$+Chr$(1)+wininhalt$+")")
letzter$="WinActive"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_WinClose(wintitel$,wininhalt$=-1)
AI_Intern_Write("WinClose("+wintitel$+Chr$(1)+wininhalt$+")")
letzter$="WinClose"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_WinKill(wintitel$,wininhalt$=-1)
AI_Intern_Write("WinKill("+wintitel$+Chr$(1)+wininhalt$+")")
letzter$="WinKill"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_WinExists(wintitel$,wininhalt$=-1)
AI_Intern_Write("WinExists("+wintitel$+Chr$(1)+wininhalt$+")")
letzter$="WinExists"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_WinFlash(wintitel$,wininhalt$=-1,anzahl=-1,pause=-1)
AI_Intern_Write("WinFlash("+wintitel$+Chr$(1)+wininhalt$+Chr$(1)+anzahl+Chr$(1)+pause+")")
letzter$="WinFlash"
ret=AI_Intern_waitReturn()
Return ret
End Function

Function AI_Intern_KeyDelay(del)
AI_Intern_Write("KeyDelay("+del+")")
letzter$="KeyDelay"
End Function

Function AI_Intern_Write(txt$)
AI_in=OpenFile(AI_Pfad$+"AI_in.ai")
While Not Eof(AI_in)
ReadLine(AI_in)
WaitTimer AI_Timer
Wend
WriteLine AI_in, txt$
CloseFile AI_in
End Function

Function AI_Intern_WaitReturn$()
AI_out=ReadFile(AI_Pfad$+"AI_out.ai")
	While 1
		While Not Eof(AI_out)
		txt$=ReadLine(AI_out)
		anf$=Mid$(txt$,1,11)
			If naechstes=1
				CloseFile AI_out
				AI_out=WriteFile (AI_Pfad$+"AI_out.ai")
				CloseFile AI_out
				Return txt$
			EndIf
			If txt$=letzter$ Then naechstes=1
			WaitTimer AI_Timer
		Wend
		CloseFile AI_out
		AI_out=ReadFile(AI_Pfad$+"AI_out.ai")
		WaitTimer AI_Timer
	Wend
CloseFile(AI_out)
End Function